Bugzilla (bugzilla.redhat.com) will be under maintenance for infrastructure upgrades and will not be unavailable on July 31st between 12:30 AM - 05:30 AM UTC. We appreciate your understanding and patience. You can follow status.redhat.com for details.
Bug 888271 - snmpd should be careful about dlmod'ed modules when reloading configuration
Summary: snmpd should be careful about dlmod'ed modules when reloading configuration
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: net-snmp
Version: 5.9
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Jan Safranek
QA Contact: BaseOS QE Security Team
URL:
Whiteboard:
Depends On:
Blocks: 888275
TreeView+ depends on / blocked
 
Reported: 2012-12-18 12:26 UTC by Jan Pokorný [poki]
Modified: 2013-03-12 11:54 UTC (History)
0 users

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 888275 (view as bug list)
Environment:
Last Closed: 2013-03-12 11:54:56 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description Jan Pokorný [poki] 2012-12-18 12:26:53 UTC
Investigation of [bug 847289] showed snmpd is not careful about dynamic
modules when it comes to reloading the configuration (such as upon
receiving SIGHUP).

Dynamic modules seems to be loaded anew, which may corrupt previous
instances, avoid a proper cleanup actions and the like.
As per Jan Safranek, there is a room for improvement and less
error-prone behavior.

Comment 1 Jan Safranek 2012-12-18 12:32:15 UTC
snmpd should not call init_<modulename> when the module is already loaded.

This implies that snmpd never reloads modules and the only way to update a module is to restart snmpd.

Comment 2 Jan Pokorný [poki] 2012-12-18 15:25:04 UTC
Sorry for the noise, I came to the conclusion the current behavior is
OK and the limitation + solution are known [1].

Unless there is another issue with the current state, I would prefer
it as a status quo (maybe a sanity check at other dynamic modules we
provide should be performed -- generally, unregister registered MIBs
and registered alarms in deinit_<module> function).

[1] http://www.net-snmp.org/wiki/index.php/TUT:Writing_a_Dynamically_Loadable_Object#Initialization

Comment 3 Jan Pokorný [poki] 2012-12-20 13:32:14 UTC
FWIW, there seem to be much more issues with reloading snmpd,
see, e.g., [2, 3].

[2] http://sourceforge.net/p/net-snmp/patches/1244/
[3] http://sourceforge.net/p/net-snmp/patches/1131/

Comment 4 Jan Safranek 2013-03-12 11:54:56 UTC
Link [1] shows that it's module responsibility to track its init_ calls, I'm closing this bug.


Note You need to log in before you can comment on or make changes to this bug.